-------------------------------------------------------------------------------
-- 
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
library fplib;
use fplib.pkg_fp_sin_cos_fcos.all;

entity fp_sin_cos_fcos is
  generic ( wF : positive );
  port ( x : in  std_logic_vector(wF+1 downto 0);
         r : out std_logic_vector(wF+2 downto 0) );
end entity;

architecture arch of fp_sin_cos_fcos is
begin -------------------------------------------------------------------------

  fcos_9 : if wF = 9 generate
    fcos : fp_sin_cos_fcos_9
      port map ( x => x,
                 r => r );
  end generate;

  fcos_10 : if wF = 10 generate
    fcos : fp_sin_cos_fcos_10
      port map ( x => x,
                 r => r );
  end generate;

  fcos_12 : if wF = 12 generate
    fcos : fp_sin_cos_fcos_12
      port map ( x => x,
                 r => r );
  end generate;

  fcos_13 : if wF = 13 generate
    fcos : fp_sin_cos_fcos_13
      port map ( x => x,
                 r => r );
  end generate;

  fcos_15 : if wF = 15 generate
    fcos : fp_sin_cos_fcos_15
      port map ( x => x,
                 r => r );
  end generate;

  fcos_16 : if wF = 16 generate
    fcos : fp_sin_cos_fcos_16
      port map ( x => x,
                 r => r );
  end generate;

  fcos_19 : if wF = 19 generate
    fcos : fp_sin_cos_fcos_19
      port map ( x => x,
                 r => r );
  end generate;

  fcos_20 : if wF = 20 generate
    fcos : fp_sin_cos_fcos_20
      port map ( x => x,
                 r => r );
  end generate;

  fcos_22 : if wF = 22 generate
    fcos : fp_sin_cos_fcos_22
      port map ( x => x,
                 r => r );
  end generate;

  fcos_23 : if wF = 23 generate
    fcos : fp_sin_cos_fcos_23
      port map ( x => x,
                 r => r );
  end generate;

end architecture; -------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
library fplib;
use fplib.pkg_fp_sin_cos_fcos.all;

entity fp_sin_cos_fcos_clk is
  generic ( wF : positive );
  port ( x : in  std_logic_vector(wF+1 downto 0);
         r : out std_logic_vector(wF+2 downto 0);
         clk : in  std_logic );
end entity;

architecture arch of fp_sin_cos_fcos_clk is
begin -------------------------------------------------------------------------

  fcos_23 : if wF = 23 generate
    fcos : fp_sin_cos_fcos_23_clk
      port map ( x => x,
                 r => r,
                 clk => clk );
  end generate;

end architecture; -------------------------------------------------------------
