-------------------------------------------------------------------------------
-- 
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
library fplib;
use fplib.pkg_fp_sin_cos_fsin.all;

entity fp_sin_cos_fsin is
  generic ( wF : positive );
  port ( x : in  std_logic_vector(wF+1 downto 0);
         r : out std_logic_vector(wF+2 downto 0) );
end entity;

architecture arch of fp_sin_cos_fsin is
begin -------------------------------------------------------------------------

  fsin_9 : if wF = 9 generate
    fsin : fp_sin_cos_fsin_9
      port map ( x => x,
                 r => r );
  end generate;

  fsin_10 : if wF = 10 generate
    fsin : fp_sin_cos_fsin_10
      port map ( x => x,
                 r => r );
  end generate;

  fsin_12 : if wF = 12 generate
    fsin : fp_sin_cos_fsin_12
      port map ( x => x,
                 r => r );
  end generate;

  fsin_13 : if wF = 13 generate
    fsin : fp_sin_cos_fsin_13
      port map ( x => x,
                 r => r );
  end generate;

  fsin_15 : if wF = 15 generate
    fsin : fp_sin_cos_fsin_15
      port map ( x => x,
                 r => r );
  end generate;

  fsin_16 : if wF = 16 generate
    fsin : fp_sin_cos_fsin_16
      port map ( x => x,
                 r => r );
  end generate;

  fsin_19 : if wF = 19 generate
    fsin : fp_sin_cos_fsin_19
      port map ( x => x,
                 r => r );
  end generate;

  fsin_20 : if wF = 20 generate
    fsin : fp_sin_cos_fsin_20
      port map ( x => x,
                 r => r );
  end generate;

  fsin_22 : if wF = 22 generate
    fsin : fp_sin_cos_fsin_22
      port map ( x => x,
                 r => r );
  end generate;

  fsin_23 : if wF = 23 generate
    fsin : fp_sin_cos_fsin_23
      port map ( x => x,
                 r => r );
  end generate;

end architecture; -------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
library fplib;
use fplib.pkg_fp_sin_cos_fsin.all;

entity fp_sin_cos_fsin_clk is
  generic ( wF : positive );
  port ( x : in  std_logic_vector(wF+1 downto 0);
         r : out std_logic_vector(wF+2 downto 0);
         clk : in  std_logic );
end entity;

architecture arch of fp_sin_cos_fsin_clk is
begin -------------------------------------------------------------------------

  fsin_23 : if wF = 23 generate
    fsin : fp_sin_cos_fsin_23_clk
      port map ( x => x,
                 r => r,
                 clk => clk );
  end generate;

end architecture; -------------------------------------------------------------
